#ifndef DICCIONARIO_H
#define DICCIONARIO_H

#include "Constantes.h"

struct _diccionario;

typedef struct _diccionario * Diccionario;

Diccionario CrearDiccionario();

//Agrega una palabra al diccionario. Esta operacin debe realizarse en a lo sumo O(log2 n) promedio.
//Ingresa una palabra al diccionario si sta no se encuentra en el mismo.
TipoRetorno IngresarPalabraDiccionario(Diccionario & D, Cadena palabraAIngresar);

//Borra una palabra del diccionario si se encuentra en el mismo.
TipoRetorno BorrarPalabraDiccionario(Diccionario & D, Cadena palabraABorrar);

//Devuelve true si la palabra pertenece al diccionario false en caso contrario
bool PertenecePalabraDiccionario(Diccionario D, Cadena palabra);

//Devuelve true si el diccionario esta vacio false en caso contrario.
bool esVacioDiccionario(Diccionario D);

//Muestra las palabras del diccionario odenadas alfabticamente, de menor a mayor. 
//Esta operacin debe realizarse en O(n) peor caso.
//Cuando el diccionario no tiene palabras debe mostrarse el mensaje "Diccionario vacio".
TipoRetorno ImprimirDiccionario(Diccionario D);


#endif
