#ifndef TEXTO_H
#define TEXTO_H

#include "Palabras.h"

struct _texto;

typedef struct _texto * Texto;

//Crea un texto vaco
Texto CrearTexto();

//Inserta una nueva lnea vaca al final del texto. 
TipoRetorno InsertarLinea(Texto & texto);

//Inserta una nueva lnea vaca en la posicin indicada.
TipoRetorno InsertarLineaEnPosicion(Texto & texto, Posicion posicionLinea);

//Borra la lnea en la posicin indicada.
TipoRetorno BorrarLinea(Texto & texto, Posicion posicionLinea);

//Borra todas las lneas del texto.
TipoRetorno BorrarTodo(Texto & texto);

//Borra todas las ocurrencias de una palabra en el texto.
TipoRetorno BorrarOcurrenciasPalabraEnTexto(Texto texto, Cadena palabraABorrar);

//Imprime el texto por pantalla.
TipoRetorno ImprimirTexto(Texto texto);

//Inserta una palabra en una lnea en la posicion dada.
TipoRetorno InsertarPalabra(Texto texto, Posicion posicionLinea, Posicion posicionPalabra, Cadena palabraAIngresar);

//Borra la palabra de una linea que se encuentra en la posicin dada.
TipoRetorno BorrarPalabra(Texto texto, Posicion posicionLinea, Posicion posicionPalabra);

//Borra todas las ocurrencias de una palabra en la lnea indicada.
TipoRetorno BorrarOcurrenciasPalabraEnLinea(Texto texto, Posicion posicionLinea, Cadena palabraABorrar);

//Imprime la lnea por pantalla.
TipoRetorno ImprimirLinea(Texto texto, Posicion posicionLinea);

//------------------Agregado Obligatorio Parte 2------------------------
//Muestra todas las lneas del texto, pero exhibiendo solamente las palabras que no se encuentran en el dicionario. 
//Se debe imprimir el nmero de lnea. Cuando el texto no tiene lneas se debe mostrar el mensaje "Texto vacio".
TipoRetorno ImprimirTextoIncorrecto(Texto T, Diccionario D);

//------------------Agregado Obligatorio Parte 2------------------------
//Imprime las ltimas palabras ingresadas. Esta operacin debe realizarse eficientemente, sin implicar adems una sobrecarga, ms que en un valor constante, sobre el tiempo de ejecucin de la operacin 7.
//Imprime las ltimas MAX_CANT_ULTIMAS_PALABRAS, a lo sumo, palabras ingresadas al texto (no al diccionario), an cuando estas palabras pudieran haber sido luego eliminadas.
//MAX_CANT_ULTIMAS_PALABRAS es una constante del sistema.
//El orden en el que se muestran las palabras debe ser el siguiente: primero la ltima palabra ingresada, luego la penltima, y as sucesivamente.
//Si nunca se ingresaron palabras se debe mostrar "No se ingresaron palabras".
TipoRetorno ImprimirUltimasPalabras(Texto T);


#endif
